{--------------------------------------------------------}
{                                                        }
{    VoxTube - utilitrio de acessibilizao do YouTube  }
{                                                        }
{    Autores:  Antonio Borges e Fabiano Ferreira         }
{                                                        }
{    Em fevereiro de 2013                                }
{                                                        }
{--------------------------------------------------------}

program voxtube;

uses
  windows,
  dvcrt,
  dvwin,
  dvHora,
  dvForm,
  dvexec,
  vtmsg,
  SysUtils,
  classes,
  shellapi,
  vtVars,
  vtrede,
  pipe,
  vtDecod,
  vtparse,
  vtyoutubedl,
  vtplay;

{--------------------------------------------------------}
{         monta a estrutura para folhear os filmes       }
{--------------------------------------------------------}

function montaFolheamento: boolean;   // retorna tambm a lista de filmes
var
    filme: TInfoFilme;
    titulo: string;
    i: integer;

begin
    window (1, 1, 80, 25);
    gotoxy (1, 3);
    clreol;
    mensagem('VTNUMLID', 0);  {'Nmero de registros lidos: '}
    sintWriteInt (listaDeFilmes.Count);

    writeln;
    textbackground (RED);
    writeln ('-------------------------------------------------------------------------------');
    textbackground (BLACK);

    window (1, wherey, 80, 25);
    folheiaCria (wherex, wherey, 80, 20);
    for i := 0 to listaDeFilmes.count-1 do
        begin
            filme := TInfoFilme(listaDeFilmes[i]^);
            titulo := filme.titulo;
            folheiaAdiciona(titulo);
        end;

    result := listaDeFilmes.Count <> 0;
end;

{--------------------------------------------------------}
{          obtem as informaes do filme                 }
{--------------------------------------------------------}

function obtemInfoFilme (ultFolheado: integer): TInfoFilme;
var
    infoFilme: TInfoFilme;

begin
    infoFilme := TInfoFilme(listaDeFilmes[ultFolheado-1]^);
    result := infoFilme;
end;

{--------------------------------------------------------}
{          descobre o tamanho de um arquivo              }
{--------------------------------------------------------}

function myFileSize(fileName: string): integer;
var
    arq: File;
begin
    assign (arq, filename);
    {$I-} reset (arq, 1); {$I+}
    if ioresult <> 0 then
         result := -1
    else
         result := filesize(arq);
    close (arq);
end;

{--------------------------------------------------------}
{          salva o audio do vdeo em formato mp3         }
{--------------------------------------------------------}

procedure extraiaudio(infofilme: TInfoFilme);
var
    nomevideo, nomeaudio, link: string;
    c: char;
    prog, params: string;
    audioBitRate, audioChannels, audioResample: string;
    comClek: boolean;
    x, sg, sgant: word;

label videoNex;

begin
    nomeaudio := subsCaracInvalidos (infoFilme.titulo + '.MP3');
    nomevideo := subsCaracInvalidos (infoFilme.titulo + '.MP4');
    link := linkReal(infoFilme.paginaweb);

    mensagem ('VTSALVP', 0);  {'Salvando para: '}
    sintWriteln (nomeaudio);
    writeln;

    mensagem ('VTEDITE', 1);  {'Editore o nome, tecle enter para confirmar, esc para cancelar.'}
    c := sintEditacampo(nomeaudio, wherex, wherey, 200, 80, true);
    if (c = ESC) or (nomeaudio = '') then
        begin
            writeln;
            mensagem ('VTDESIST', 1);  {'Desistiu'}
            exit;
        end;

    writeln (nomeaudio);
    if fileExists(nomeaudio) then
        begin
            mensagem ('VTARQEXI', 0);  {'Este arquivo j existe. Sobrescreve?'}
            c := popupMenuPorLetra ('SN');
            if (c <> 'S') then
                begin
                    mensagem ('VTDESIST', 1);  {'Desistiu'}
                    exit;
                end;
        end;

    writeln;

    mensagem ('VTBAIXVD', 1); {'Baixando o vdeo, aguarde.'}
    if not download(link, nomevideo) then
        begin
            mensagem ('VTNAOCVA', 1); {'No consegui obter o vdeo para gerar o audio.'}
            mensagem ('VTOPCANC', 1); {'Operao foi cancelada.'}
            exit;
        end;

    prog := sintambiente('DOSVOX','PGMDOSVOX') + '\ffmpeg.exe';

    audioBitRate := sintAmbiente('VOXTUBE','AUDIOBITRATE');
    if audioBitRate = '' then audioBitRate := '128000';
    audioChannels := sintAmbiente('VOXTUBE','AUDIOCHANELS');
    if audioChannels = '' then audioChannels := '2';
    audioResample :=    sintAmbiente('VOXTUBE','AUDIORESAMPLE');
    if audioResample = '' then audioResample := '44100';

    params :=
        '-i "' + nomevideo + '"' +
        ' -ab ' + audioBitRate +
        ' -ac ' + audioChannels +
        ' -ar ' + audioResample +
        ' -y "' + nomeaudio + '"';

    executaProgEx (prog, '', params, sw_hide);

    mensagem ('VTINCVMP', 1);  {'Iniciando converso para mp3.'}
    while sintFalando do
        waitMessage;
    delay (1000);  // garante que o FFMPEG comece

    comClek := false;
    getTime (x, x, sgant, x);
    while processExists('ffmpeg.exe') do
        begin
            if keypressed then
                begin
                    c := readkey;
                    if c = ENTER then
                        begin
                            mensagem ('VTGERAN', 0);    {'Gerando mp3: '}
                            sintWriteln (nomeaudio);
                            sintWrite(intToStr(myFileSize(nomeAudio) div 1024) + 'k');
                            mensagem ('VTESCRDK', 1);   {' escritos em disco'}
                        end
                    else
                    if c = ' ' then
                        comClek := not comClek
                    else
                    if c = ESC then
                        begin
                            mensagem ('VTPARACV', 0);  {'Deseja parar a converso?'}
                            c := popupMenuPorLetra ('SN');
                            if upcase(c) = 'S' then
                                begin
                                    executaProgEx ('taskKill','','/f /im ffmpeg.exe', sw_hide);
                                    mensagem ('VTXACANC', 2); {'Extrao de audio foi cancelada.'}
                                    exit;
                                end;
                        end;
                end;

            if comClek then
                begin
                    getTime (x, x, sg, x);
                    if sg <> sgant then
                        begin
                            sgant := sg;
                            sintCarac (' ');
                        end;
                end;
        end;

    mensagem ('VTXTAOK', 2);  {'Extrao de audio concluda!'}

    {$I-} deleteFile (nomevideo);  {$I+}
    ioresult;
end;

{--------------------------------------------------------}
{                     salva o filme                      }
{--------------------------------------------------------}

procedure salvaFilme (infoFilme: TInfoFilme);
var
    arquivo: string;
    c: char;
    baixar: string;

begin
    arquivo := subsCaracInvalidos (infoFilme.titulo + '.MP4');
    baixar := linkReal(infoFilme.paginaweb);
    if baixar = '' then
        begin
            mensagem ('VTDECERR', 1);  {'No  possvel baixar esse vdeo. Sinto muito.'}
            exit;
        end;

    mensagem ('VTSALVP', 0);  {'Salvando para: '}
    sintWriteln (arquivo);
    writeln;

    mensagem ('VTEDITE', 1);  {'Editore o nome, tecle enter para confirmar, esc para cancelar.'}
    c := sintEditacampo(arquivo, wherex, wherey, 200, 80, true);
    if (c = ESC) or (arquivo = '') then
        begin
            mensagem ('VTDESIST', 1);  {'Desistiu'}
            exit;
        end;

    writeln (arquivo);
    if fileExists(arquivo) then
         begin
              mensagem ('VTARQEXI', 0);  {'Este arquivo j existe. Sobrescreve?'}
              c := popupMenuPorLetra ('SN');
              if (c <> 'S') then
                 begin
                    mensagem ('VTDESIST', 1);  {'Desistiu'}
                    exit;
                 end;
         end;

    writeln;

    mensagem ('VTBAIXVD', 1); {'Baixando o vdeo, aguarde.'}
    if download(baixar, arquivo) then
        mensagem ('VTOK', 1);  {'Ok!'}
end;

{--------------------------------------------------------}
{                       ajuda                            }
{--------------------------------------------------------}

procedure ajuda;
begin
    writeln;
    mensagem ('VTOPCAO', 1);   {'As opes so:'}
    mensagem ('VTOP_ENT', 1);  {'ENTER - inicia a execuo do vdeo'}
    mensagem ('VTOP_I', 1);    {'I - informaes sobre o vdeo'}
    mensagem ('VTOP_P', 1);    {'P - prximos vdeos'}
    mensagem ('VTOP_A', 1);    {'A - vdeos anteriores'}
    mensagem ('VTOP_Q', 1);    {'Q - informa a posio na lista de vdeos'}
    mensagem ('VTOP_S', 1);    {'S - salvar vdeo'}
    mensagem ('VTOP_M', 1);    {'M - gravar o audio do vdeo selecionado em mp3'}
    mensagem ('VTOP_CTC', 1);  {'ctrl+c - copia o ttulo e o link dos vdeos'}
    mensagem ('VTOP_CTL', 1);  {'ctrl+l - copia o link do vdeo atual'}
    mensagem ('VTOP_CTEN', 1); {'ctrl+enter - exibe o vdeo com o navegador padro'}
    mensagem ('VTOP_ESC', 2);  {'ESC - Cancelar'}
    readkey;
    limpaBufTec;
end;

{--------------------------------------------------------}

procedure menuAdiciona (cod: string);
begin
    popupMenuAdiciona (cod, pegaTextoMensagem(cod));
end;

function selSetasOpcao: char;
var n: integer;
const
    opmenu: string = ^m + 'IPAQSM' + ^C + ^L + ^J + #$1b;
begin
    mensagem ('VTSELSET', 2); {'Selecione com as setas a opo desejada:'}

    popupMenuCria(wherex, wherey, 50, 11, RED);
    MenuAdiciona ('VTOP_ENT');  {'ENTER - inicia a execuo do vdeo'}
    MenuAdiciona ('VTOP_I');    {'I - informaes sobre o vdeo'}
    MenuAdiciona ('VTOP_P');    {'P - prximos vdeos'}
    MenuAdiciona ('VTOP_A');    {'A - vdeos anteriores'}
    MenuAdiciona ('VTOP_Q');    {'Q - informa a posio na lista de vdeos'}
    MenuAdiciona ('VTOP_S');    {'S - salvar vdeo'}
    MenuAdiciona ('VTOP_M');    {'M - gravar o audio do vdeo selecionado em mp3'}
    MenuAdiciona ('VTOP_CTC');  {'ctrl+c - copia o ttulo e o link dos vdeos'}
    MenuAdiciona ('VTOP_CTL');  {'ctrl+l - copia o link do vdeo atual'}
    menuAdiciona ('VTOP_CTEN'); {'ctrl+enter - exibe o vdeo com o navegador padro'}
    MenuAdiciona ('VTOP_ESC');  {'ESC - Cancelar'}

    n := popupMenuSeleciona;
    if (n < 1) then
        result := ' '
    else
        result := opmenu[n];
end;

{--------------------------------------------------------}
{       folheia os vdeos informados pelo youtube
{--------------------------------------------------------}

procedure processaFuncao (c1, c2: char;
                         ultFolheado: integer;
                         var mudouPagina: boolean);
var clipboardAcum : string;
    i: integer;
    texto: string;
    estaSelec: boolean;
    infoFilme: TInfoFilme;

const
    CRLF = ^m^j;
label denovo, informenomedoarquivo, fazdownload;

const
    NOPLAYER = false;
    NONAVEGADOR = true;

begin
    mudouPagina := false;

denovo:
    clrscr;
    infoFilme := obtemInfoFilme (ultFolheado);

    case upcase(c1) of
        ESC:  begin
                  mensagem ('VTFOLTRM', 1); {'Folheamento terminado'}
                  mudouPagina := true;
              end;

        ENTER:
            begin
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
                tocavideo (infoFilme.paginaWeb, NOPLAYER);
            end;

        #10:   tocavideo (infoFilme.paginaWeb, NONAVEGADOR);

        'S': begin
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
                salvaFilme (infoFilme);
             end;

        'M': begin
                mensagem ('VTMOMENT', 1);   {'Um momento.'}
                Extraiaudio(infofilme);
             end;

        'P': begin
                 sintbip; sintbip;
                 sintWriteln ('Funo desabilitada na verso alfa');
                 if false then
                 begin
                     pagAtual := pagAtual + 1;
                     mudouPagina := true;
                     sintClek; sintClek;
                 end;
             end;

        'A': if pagAtual > 1 then
                 begin
                     pagAtual := pagAtual - 1;
                     mudouPagina := true;
                     sintClek; sintClek;
                 end
             else
                 sintBip;

        'Q': begin
                sintClek;
                textColor (YELLOW);
                writeln (infoFilme.titulo);
                textColor (WHITE);
                writeln;
                mensagem('VTNUMLID', 0);  {'Nmero de registros lidos: '}
                sintWriteInt (listaDeFilmes.Count);
                mensagem ('VTUNIVER', 0); {' de um universo de '}
                sintWriteln (intToStr(quantTotal) + ' links.');
                writeln;
                sintWriteln ('Posio ' + intToStr (ultFolheado) +
                             ' da pgina ' + intToStr (pagAtual) + '.');
                writeln;
                mensagem ('VTAPTENT', 0); {'Aperte enter'}
                readln;
                sintClek;
             end;

        'I': begin
                 textColor (yellow);
                 writeln (infoFilme.titulo);
                 textColor (white);

                 sintClek;
                 writeln;
                 sintWriteln (infoFilme.conteudo);
                 writeln;

                 sintClek;
                 mensagem ('VTAUTOR', 0);  {'Autor: '}
                 textColor (yellow);
                 sintWriteln (infoFilme.autor);

                 if infoFilme.canal then
                     begin
                         sintClek;
                         sintWriteln (infoFilme.visualizacoes);
                         textColor (white);
                     end
                 else
                     begin
                         if infoFilme.publicado <> '' then
                             begin
                                 sintClek;
                                 textColor (white);
                                 mensagem ('VTTRANSM', 0);   {'Transmitido em: '}
                                 textColor (yellow);
                                 sintWriteln (infoFilme.publicado);
                                 textColor (white);
                             end;

                         sintClek;
                         textColor (white);
                         mensagem ('VTDURA', 0);   {'Durao: '}
                         textColor (yellow);
                         sintWriteln (infoFilme.duracao);

                         sintClek;
                         textColor (white);
                         mensagem ('VTVISUAL', 0);  {'Visualizaes: '}
                         textColor (yellow);
                         sintWriteln (infoFilme.visualizacoes);
                     end;

                 textColor (white);
                 writeln;
                 mensagem ('VTAPTENT', 0);    {'Aperte enter...'}
//Neno                 readln;
                 readkey;
                 limpaBufTec;
             end;

        ^C:  // control-c   -->  titulo<crlf>paginaweb<crlf>
             begin
                clipboardAcum := '';
                for i := 1 to folheiaNumItens do
                    begin
                        folheiaObtemItem(i, texto, estaSelec);
                        if estaSelec then
                            begin
                                infoFilme := obtemInfoFilme(i);
                                clipboardAcum := clipboardAcum + infoFilme.titulo
                                    + ': ' + infoFilme.paginaWeb+ CRLF;
                            end;
                    end;

                if clipboardAcum = '' then
                    begin
                        infoFilme := obtemInfoFilme(ultFolheado);
                        clipboardAcum := clipboardAcum + infoFilme.titulo
                                    + ': ' + infoFilme.paginaWeb + CRLF;
                    end;

                putClipboard (pchar(clipboardAcum));
                sintclek;
             end;

        ^l:
            begin
                infoFilme := obtemInfoFilme(ultFolheado);
                clipboardAcum := clipboardAcum + infoFilme.paginaWeb + CRLF;
                putClipboard (pchar(clipboardAcum));
                sintclek;
            end;

        #0:  case c2 of
                 DIR: sintetiza (infoFilme.autor);
                 CTLDIR: sintetiza (infoFilme.conteudo);
                 ESQ: sintetiza (infoFilme.publicado);
                 CTLESQ: sintetiza (infoFilme.duracao);
                 DEL: sintetiza (versao);
                 F1: ajuda;
                 F8: falaHora;
                 CTLF8: falaDia;
                 F9: begin
                        if ultFolheado > 0 then
                            begin
                                writeln (infoFilme.titulo);
                                writeln;
                            end;

                         c1 := selSetasOpcao;
                         goto denovo;
                     end;
             end;
    end;
end;

{--------------------------------------------------------}
{       folheia os vdeos informados pelo youtube
{--------------------------------------------------------}

function folheiaVideos: char;
var c1, c2: char;
    ultFolheado: integer;
    mudouPagina, podeFalar: boolean;

begin
    ultFolheado := 1;
    c1 := ' ';
    podeFalar := true;
    repeat
        clrscr;

        if folheiaExecuta(ultFolheado, ultFolheado, c1, c2, podeFalar) then
            processaFuncao (c1, c2, ultFolheado, mudouPagina)
        else
            sintBip;

        if (c1 = #0) and (c2 in [DIR, ESQ, CTLDIR, CTLESQ, DEL, F8, CTLF8]) then
            podeFalar := false
        else
            podeFalar := true;

    until mudouPagina or (c1 = ESC);
    result := c1;
end;

{--------------------------------------------------------}
{                   mostra ou fala cabealho
{--------------------------------------------------------}

procedure cabecalho (falando: boolean);
begin
    textbackground (BLUE);
    if falando and sintFalarTudo then
        begin
            mensagem ('VTINIC',0);    {'Programa de Pesquisa no YouTube'}
            sintWriteln (VERSAO);
        end
    else
         writeln (pegaTextoMensagem('VTINIC') + VERSAO);
    textbackground (BLACK);
end;

{--------------------------------------------------------}
{                   programa principal
{--------------------------------------------------------}

procedure processaBusca (busca: string);
var
    comando: string;
    s: string;
    quantosLinks: integer;
    c1: char;

begin
    pagAtual := 1;
    c1 := ' ';
    repeat
        gotoxy (1, 3);

        comando := '/results?search_query='+stringToURL(AnsiToUtf8(busca));
        if pagAtual > 1 then
            comando := comando + '&page=' + intToStr(pagAtual);

        s := pedeAoYoutube (comando);
        quantosLinks := 0;
        if s <> '' then
            begin
                quantosLinks := geraListaDeFilmes (s);
                if montaFolheamento then
                    c1 := folheiaVideos;
                folheiaDestroi;

                if (quantosLinks = 0) and (pagAtual > 1) then
                    begin
                        sintBip; sintBip;
                        mensagem ('VTULTPGV', 0);   {'ltima pgina, voltando.'}
                        pagAtual := pagAtual - 1;
                        quantosLinks := -1;
                    end;
            end;
    until (s = '') or (c1 = ESC) or
           ((quantosLinks = 0) and (pagAtual = 1));
end;

{--------------------------------------------------------}
{                   programa principal
{--------------------------------------------------------}

procedure inicializa;
var i: integer;
    dir: string;
begin
    clrscr;
    listaDeFilmes := TList.Create;

    setWindowTitle('VoxTube ' + VERSAO);
    dir := sintambiente('VOXTUBE', 'DIRVOXTUBE');
    if dir = '' then
        dir := '\winvox\som\voxtube';
    sintInic (0, dir);

    for i := 1 to 10 do
        ultimasBuscas[i] := sintAmbiente ('VOXTUBE', intToStr(i));
end;

{--------------------------------------------------------}
{           escolhe uma entre as ltimas buscas          }
{--------------------------------------------------------}

function escolheBusca: string;
var i: integer;
begin
    garanteEspacoTela (10);
    popupMenuCria(wherex, wherey, 80, 10, MAGENTA);
    for i := 1 to 10 do
        if ultimasBuscas[i] <> '' then
            popupMenuAdiciona('', ultimasBuscas[i]);
    popupMenuSeleciona;
    result := opcoesItemSelecionado;
end;

{-----------------------------------------------------------}
{          rotinas de criao e exibio da janela
{-----------------------------------------------------------}

procedure adicionaAosUltimos (chaveBusca: string);
var i, j: integer;
begin
    for i := 1 to 10 do
        begin
            if chaveBusca = ultimasBuscas[i] then
                begin
                    for j := i to 10-1 do
                        ultimasBuscas[j] := ultimasBuscas[j+1];
                    ultimasBuscas[10] := '';
                end;
        end;

    if (chaveBusca <> '') and (chaveBusca <> ultimasBuscas[1]) then
       begin
           for i := 10 downto 2 do
               ultimasBuscas[i] := ultimasBuscas[i-1];
           ultimasBuscas[1] := chaveBusca;
           for i := 1 to 10 do
               sintGravaAmbiente ('VOXTUBE', intToStr(i), ultimasBuscas[i]);
       end;
end;

{-----------------------------------------------------------}
{                 Ajuda da configurao
{-----------------------------------------------------------}

procedure configura;
var
    n: integer;
const
// Retirada a atualizao do youtube-dl. opmenu: string = 'HCAD';
    opmenu: string = 'D';
begin
    writeln;
    mensagem ('VTSELCNF', 1);  {'Selecione com as setas a opo de configurao:'}

    popupMenuCria(1, wherey, 40, length(opmenu), RED);
//    MenuAdiciona('VTOP_MAI');       {'H - Habilita atualizao automtica'}
//    MenuAdiciona('VTOP_MEN');       {'C - Cancela atualizao automtica'}
//    MenuAdiciona('VTOP_ATU');       {'A - Atualiza o mdulo de vdeo'}
    MenuAdiciona('VTOP_DEB');       {'D - Ativa modo debug para programadores'}
    n := popupMenuSeleciona;

    if (n < 1) then
        mensagem ('VTOK', 2)       {'Ok!'}
    else
        begin
            case opmenu[n] of
                'H':  begin
                          sintGravaAmbiente ('VOXTUBE', 'ATUALIZAR', 'SIM');
                          atualizaYoutube_dl;
                      end;
                'C':  sintGravaAmbiente ('VOXTUBE', 'ATUALIZAR', 'NO');
                'A':  atualizaYoutube_dl;
                'D':  debug := not debug;
            end;
            mensagem ('VTOK', 2);
        end;

    limpaBufTec;
end;

{-----------------------------------------------------------}
{                     loop de processamento
{-----------------------------------------------------------}

procedure processa;
var
    primeiraVez: boolean;
    c: char;
    busca: string;

label inicio, fim;

begin
    debug := false;
    primeiraVez := true;
    repeat
        window (1, 1, 80, 25);
        clrscr;

        cabecalho (primeiraVez);
// Retirada a atualizao automtica do youtube-dl.        if primeiraVez and
//            (upcase((sintambiente('VOXTUBE','ATUALIZAR')+'S')[1]) = 'S') then
//                atualizaYoutube_dl;
        primeiraVez := false;

        gotoxy (1, 2);
        mensagem ('VTQBUSCA', 0);   {'Qual sua busca: '}
        busca := '';
        c := sintEditaCampo (busca, wherex, wherey, 200, 80, true);
        writeln;

        if c = CTLHOME then
             begin
                 mensagem ('VTINIC',-1);    {'Programa de Pesquisa no YouTube'}
                 sintetiza (VERSAO);
                 continue;
             end
        else
        if c = F9 then
             begin
                 configura;
                 continue;
             end
        else
        if c = BAIX then
            busca := escolheBusca
        else
        if  busca = '' then
            goto fim;

        adicionaAosUltimos(busca);
        processaBusca (busca);

        clrscr;
fim:
        mensagem ('VTOUTRO', 0);   {'Deseja pesquisar outro assunto? '}
        c := upcase(popupMenuPorLetra ('SN'));
    until c in ['N', ESC];
end;

{--------------------------------------------------------}
{                   programa principal
{--------------------------------------------------------}

begin
    inicializa;
    processa;

    clrscr;
    mensagem ('VTFIM',1); {'Fim do programa'}
    delay (1000);
    sintfim;
    doneWinCrt;
end.
