unit vtparse;

interface
uses
    dvwin,
    sysutils,
    vtvars,
    vtmsg,
    classes,
    SuperObject;

procedure limpaListaDeFilmes;
function geraListaDeFilmes (lidoYoutube: string): integer;

implementation

{--------------------------------------------------------}
{         limpa a lista de filmes e seus registros
{--------------------------------------------------------}

procedure limpaListaDeFilmes;
var i: integer;
begin
    for i := 0 to listaDeFilmes.Count-1 do
        Dispose (listaDeFilmes[i]);
    listaDeFilmes.Clear;
end;

{--------------------------------------------------------}
{     gera a lista de filmes a partir de tagsPagina
{--------------------------------------------------------}

function geraListaDeFilmes (lidoYoutube: string): integer;
                                    // retorna quantos links achou
var
    i, ct, quantosLinks: integer;
    novoFilme: ^TInfoFilme;
    obj: ISuperObject;
    cont1, contents, sniptext: TSuperArray;
    ob, item, video: ISuperObject;
    itera: TSuperObjectIter;
    dbg: TStringList;
    p: integer;
    jsonData: string;
    contlLength: integer;

const youtube = 'https://www.youtube.com/watch?v=';

    function criaSuperObject (s: string): ISuperObject;
    var w: WideString;
    begin
        w := s;
        result := TSuperObject.ParseString (pwideChar(w), false);
    end;

    function extraiTexto (tarray: TSuperArray): string;
    var s: string;
        i: integer;
    begin
        s := '';
        for i := 0 to tarray.length-1 do
            s := s + tarray[i]['text'].AsString;
        for i := length(s)-3 downto 1 do
            if ord(s[i]) >= $f0 then
                begin
                    delete (s, i, 3);
                    s[i] := '*';
                end;
        result := utf8ToAnsi(s);
    end;

begin
    result := 0;

    if debug then
        begin
            dbg :=TStringList.Create;
            dbg.add(lidoYoutube);
            dbg.SaveToFile('c:\temp\vt_'+ultimasBuscas[1]+'.htm');
            dbg.Free;
        end;

    p := pos ('// scraper_data_begin', lidoYoutube);
    if p > 0 then
        begin
            delete (lidoYoutube, 1, p-1);
            p := pos ('{', lidoYoutube);
            delete (lidoYoutube, 1, p-1);

            p := pos ('// scraper_data_end', lidoYoutube);
            if p = 0 then
                begin
                    mensagem ('VTEDELIM', 1);  {'rea de dados no delimitada'}
                    mensagem ('VTPGNPRO', 2);  {'Pgina do Youtube no pode ser processada'}
                    exit;
                end;

            for p := p-1 downto 1 do
                if lidoYoutube[p] = '}' then break;
            delete (lidoYoutube, p+1, 999999);
        end
    else
        begin
            p := pos ('ytInitialData', lidoYoutube);
            if p <= 0 then
                begin
                    mensagem ('VTEDADOS', 1);  {'rea de dados no foi encontrada'}
                    mensagem ('VTPGNPRO', 2); {'Pgina do Youtube no pode ser processada'}
                    exit;
                end;

            delete (lidoYouTube, 1, p+13);
            p := pos ('{', lidoYouTube);
            delete (lidoYouTube, 1, p-1);
            p := pos ('</script><script', lidoYoutube);
            repeat
                p := p - 1;
            until lidoYoutube[p] = '}';
            delete (lidoYoutube, p+1, 9999999);
        end;

    jsonData := lidoYoutube;
    if debug then
        begin
            dbg :=TStringList.Create;
            dbg.add(jsonData);
            dbg.SaveToFile('c:\temp\'+ultimasBuscas[1]+'.json');
            dbg.Free;
        end;

    quantosLinks := 0;
    limpaListaDeFilmes;

    obj := criaSuperObject(jsonData);
    cont1 := NIL;

    try
        quantTotal := obj['estimatedResults'].AsInteger;
        ob := obj['contents']['twoColumnSearchResultsRenderer']['primaryContents'];
        cont1 := ob['sectionListRenderer']['contents'].asArray;
        contlLength := cont1.length;
    except
        contlLength := 0;
    end;

    for ct := 0 to contlLength-1 do
        begin
            try
                contents := cont1[ct]['itemSectionRenderer']['contents'].asArray;
            except break; end;

            for i := 0 to contents.length-1 do
                begin
                    item := contents[i];
                    if ObjectFindFirst (item, itera) then
                        repeat
                            if itera.key = 'videoRenderer' then
                                begin
                                    quantosLinks := quantosLinks + 1;
                                    new (novoFilme);
                                    listaDeFilmes.Add(novoFilme);

                                    video := item['videoRenderer'];
                                    with novoFilme^ do
                                        begin
                                            try paginaWeb := youtube + video['videoId'].asString;
                                            except end;

                                            canal := false;

                                            try titulo := extraiTexto(video['title']['runs'].asArray);
                                            except end;

                                            try duracao := video['lengthText']['accessibility']['accessibilityData']['label'].asString;
                                            except duracao := ''; end;
                                            if duracao = '' then
                                                try duracao := video['lengthText']['simpleText'].asString;
                                                except end;
                                            duracao := utf8ToAnsi(duracao);

                                            try autor := extraiTexto(video['ownerText']['runs'].asArray);
                                            except autor := ''; end;

                                            try publicado := video['publishedTimeText']['simpleText'].asString;
                                            except publicado := ''; end;
                                            publicado := utf8ToAnsi(publicado);

                                            try visualizacoes := video['viewCountText']['simpleText'].asString;
                                            except visualizacoes := ''; end;
                                            visualizacoes := utf8ToAnsi(visualizacoes);
                                            if visualizacoes = '' then
                                                  try visualizacoes := extraiTexto(video['viewCountText']['runs'].asArray);
                                                  except end;

                                            try
                                                sniptext := video['detailedMetadataSnippets'].asArray;
                                                conteudo := extraiTexto(sniptext[0]['snippetText']['runs'].asArray);
                                            except conteudo := titulo; end;
                                        end;
                                end
                            else
                                begin
                                   // channelRenderer, shelfRenderer , horizontalCardListRenderer, radioRenderer
                                   // writeln (itera.key);
                                   // readln;
                                end;

                        until not ObjectFindNext (itera);
                    ObjectFindClose (itera);
                end;
        end;
        
    result := quantosLinks;
end;

end.

